#include <iostream>
#include <string>
#include <ukazatele.h>
#include <barvicky.h>

using namespace std;

int main () {
	cout << obarvi("*** Ukazatele ***", BARVA_ZELENA) << endl << endl;
	upravPromennou();
}

void upravPromennou() {
	int x;
	
	x= 100;
	upravSpatne(x);
	cout << obarvi("špatný výsledek: ", BARVA_ZELENA) << x << endl;
	
	x = 100;
	upravDobre(&x);
	cout << obarvi("dobrý výsledek:  ", BARVA_ZELENA) << x << endl;
	
	
	/** Nefunguje → error: invalid conversion from ‘int’ to ‘int*’ */
	//x = 100;
	//upravDobre(x);
	//cout << obarvi("dobrý výsledek:  ", BARVA_ZELENA) << x << endl;
	
	/** Nefunguje → error: invalid conversion from ‘int*’ to ‘int’ */
	//x= 100;
	//upravSpatne(&x);
	//cout << obarvi("špatný výsledek: ", BARVA_ZELENA) << x << endl;
}

/** Upravujeme pouze kopii hodnoty n – úprava platí jen v rámci této funkce */
void upravSpatne(int n) {
  n = 123;
}

/** Upravíme hodnotu v paměti, do které ukazuje *n – úprava platí globálně */
void upravDobre(int *n) {
  *n = 123;
}

